#!c:\perl\perl.exe -w

# Random Dungeon Generator from DM's Guide 1st ed. Appendix I
#   with Treasure Types from Monster Manual 1st ed.
#   and Random Encounter Tables from Monster Manual 2 1st ed.

# magic tables
# maps for you

# as monsters are encountered, adding hit_dice, xp and treasure!

use strict;
use warnings;

# use this below to get less empty rooms (12 - this number) / 20 is the chance of an empty room
my $empty_room_reducer = 10;

sub where_now {

	my $where = $_[0];
	chomp($where);
		
	system "cls";
	
	print "Where now?\n\n";
	print "1 - Passage\n";
	print "2 - Door\n";
	print "3 - Gas \n";
	print "4 - Stairs down 1 level\n";
	print "5 - Stairs down 2 levels\n";
	print "6 - Stairs down 3 levels\n";
	print "7 - Jewelry value\n";
	print "8 - Gem value\n";
	print "9 - Treasure type\n";
	print "\nor any letter for treasure type or dice in xdx format for dice roll";
	print "\n\n";
	# chamber?
	
	if ($where eq "1") {
		passage();		
	} elsif ($where eq "2") {
		door();
	} elsif ($where eq "3") {
		gas();	
	} elsif ($where eq "4") {
		stairs_down(1);
	} elsif ($where eq "5") {
		stairs_down(2);
	} elsif ($where eq "6") {
		stairs_down(3);
	} elsif ($where eq "7") {
		jewelry();
	} elsif ($where eq "8") {
		gem();	
	} elsif ($where eq "9") {
		print "Enter Treasure Type\n";
		my $tt = <STDIN>;
		chomp($tt);
		treasure_type($tt);
	} elsif (length($where) == 1) {
		treasure_type($where);
	} elsif (length($where) != 0) {
		die_roller($where);
	}

	print "\nYour Bidding Master? ";

	$where = <STDIN>;
	where_now($where);

}

sub passage {
	
	my $rnd = random_number(20);
	
	if ($rnd <= 2) {
		print "Continue stright - check again in 60'\n";
	} elsif ($rnd >=3 and $rnd <= 5) {
		door_in_passage()
	} elsif ($rnd >= 6 and $rnd <= 10) {
		side_passage();
	} elsif ($rnd >= 11 and $rnd <= 13) {
		passage_turns();
	} elsif ($rnd >= 14 and $rnd <= 16) {
		chamber();
	} elsif ($rnd == 17) {
		stairs();
	} elsif ($rnd == 18) {
		print "Dead end.  Walls can be checked for secret doors.\n";
	} elsif ($rnd == 19) {
		trick_trap();
	} elsif ($rnd == 20) {
		print "Wandering monster\n";
		monster();
		print "Below refers to area after wandering monster\n";
		passage();
	}
	
}

sub door {
	
	my $rnd = random_number(20);
	
	if ($rnd <= 4) {
		print "Paralell passage, or 10' by 10' room if door is straight ahead\n";
		print "Input 1 for passage, 2 for room\n";
		my $which = <STDIN>;
		chomp($which);
		if ($which eq "1") {
			passage_width();
		} else {
			room();
		}
	} elsif ($rnd >= 5 and $rnd <= 8) {
		print "Passage straight ahead";
		passage_width();
	} elsif ($rnd == 9) {
		print "Passage 45 degress ahead/behind (favour ahead)";
		passage_width();
	} elsif ($rnd == 10) {
		print "Passage 45 degrees behind/ahead (favour behind)";
		passage_width();
	} elsif ($rnd >= 11 and $rnd <= 18) {
		room();
	} elsif ($rnd >= 19) {
		chamber();	
	}
	
}

sub door_in_passage {
	
	my $rnd = random_number(20);
	
	if ($rnd <= 6) {
		print "Door on left\n";
	} elsif ($rnd >= 7 and $rnd <= 12) {
		print "Door on right\n";
	} elsif ($rnd <= 20) {
		print "Door straight ahead\n";
	}
}

sub side_passage() {
	
	my $rnd = random_number(20);
	
	print "Side passage: ";
	
	if ($rnd <= 2) {
		print "left 90 degrees";
	} elsif ($rnd <= 4) {
		print "right 90 degrees";
	} elsif ($rnd == 5) {
		print "left 45 degrees ahead";
	} elsif ($rnd == 6) {
		print "right 45 degrees ahead";
	} elsif ($rnd == 7) {
		print "left 45 degrees behind (135 degrees ahead)";
	} elsif ($rnd == 8) {
		print "right 45 degrees behind (135 degrees ahead)";
	} elsif ($rnd == 9) {
		print "left curve 45 degrees ahead";
	} elsif ($rnd == 10) {
		print "right curve 45 degrees ahead";
	} elsif ($rnd <= 13) {
		print "passage 'T's";
	} elsif ($rnd <= 15) {
		print "passage 'Y's";
	} elsif ($rnd <= 19) {
		print "four-way intersection";
	} elsif ($rnd == 20) {
		print "passage 'X's (if present passage is horizontal or vertical it forms a fifth passage into the 'X')";
	}
	
	passage_width();
	
}

sub passage_turns() {
	
	my $rnd = random_number(2);
	
	print "Passage turns: ";
	
	if ($rnd == 1) {
		print "left	";
	} else {
		print "right ";
	}
	
	if ($rnd <= 8) {
		print "90 degrees";
	} elsif ($rnd == 9) {
		print "45 degrees ahead";
	} elsif ($rnd == 10) {
		print "45 degrees behind";
	}
	
	passage_width();
}

# Table III.A
sub passage_width() {
	
	my $rnd = random_number(20);
	
	print ", ";
	
	if ($rnd <= 12) {
		print "10' wide";
	} elsif ($rnd <= 16) {
		print "20' wide";
	} elsif ($rnd == 17) {
		print "30' wide";
	} elsif ($rnd == 18) {
		print "5' wide";
	} else {
		my $special = random_number(20);
		if ($special <= 4) {
			print "40' wide, columns down centre";
		} elsif ($special <= 7) {
			print "40' wide, double row of columns";
		} elsif ($special <= 10) {
			print "50' wide, double row of columns";
		} elsif ($special <= 12) {
			print "50' wide, columns right and left support 10' wide upper galleries 20' above";
			my $staircase = random_number(40);
			if ($staircase <= 15) {
				print " with staircase up at this end of the passage";
			} elsif ($staircase <= 30) {
				print " with staircase up at both ends of the passage";
			} else {
				print " with staircase up at the other end of the passage";
			}
		} elsif ($special <= 15) {
			print " with 10' stream bisecting the passage";
			if (random_number(20) <= 15) {
				print " with a bridge";
			} else {
				print " with no bridge";
			}
		} elsif ($special <= 17) {
			print " with 20' river bisecting the passage";
			river();
		} elsif ($special == 18) {
			print " with 40' river bisecting the passage";
			river();
		} elsif ($special == 19) {
			print " with 60' river bisecting the passage";
			river();
		} elsif ($special == 20) {
			print " with " . ((random_number(6) * 10) + 140) . "' deep chasm bisecting the passage";
			my $chasm = random_number(20);
			if ($chasm <= 10) {
				print " with a bridge";
			} elsif ($chasm <= 15) {
				print " with a " . (random_number(6) + 4) . "' wide jumping place";
			} else {
				print " with no bridge and no jumping place";
			}
		}
	}
	
	print "\n";
}

sub chamber {

	my $rnd = random_number(20);
	my $size = 0;
	
	if ($rnd <= 4) {
		print "Square Chamber, 20' x 20'";
		$size = 400;
	} elsif ($rnd <= 6) {
		print "Square Chamber, 30' x 30'";
		$size = 900;
	} elsif ($rnd <= 8) {
		print "Square Chamber, 40' x 40'";
		$size = 1600;
	} elsif ($rnd <= 13) {
		print "Rectangular Chamber, 20' x 30'";
		$size = 600;
	} elsif ($rnd <= 15) {
		print "Rectangular Chamber, 30' x 50'";
		$size = 1500;
	} elsif ($rnd <= 17) {
		print "Rectangular Chamber, 40' x 60'";
		$size = 2400;
	} else {
		print "Unusual Chamber,";
		$size = unusual_room();
	}
	
	my $exits = exits($size);
	
	if ($exits == -1) {
		exit_location();
	} else {
		for (my $i = 0; $i < $exits; $i++) {
			exit_location();
			exit_direction();
			passage_width();
		}
	}
	
	print "\n";
	
	room_contents();

}

# Half of TABLE V
sub room {

	my $rnd = random_number(20);
	my $size = 0;
	
	if ($rnd <= 2) {
		print "Square Room, 10' x 10'";
		$size = 100;
	} elsif ($rnd <= 4) {
		print "Square Room, 20' x 20'";
		$size = 400;
	} elsif ($rnd <= 6) {
		print "Square Room, 30' x 30'";
		$size = 900;
	} elsif ($rnd <= 8) {
		print "Square Room, 40' x 40'";
		$size = 1600;
	} elsif ($rnd <= 10) {
		print "Rectangular Room, 10' x 20'";
		$size = 200;
	} elsif ($rnd <= 13) {
		print "Rectangular Room, 20' x 30'";
		$size = 600;
	} elsif ($rnd <= 15) {
		print "Rectangular Room, 20' x 40'";
		$size = 800;
	} elsif ($rnd <= 17) {
		print "Rectangular Room, 30' x 40'";
		$size = 1200;
	} else {
		print "Unusual room ";
		$size = unusual_room();
	}
	
	my $exits = exits($size);
	
	if ($exits == -1) {
		exit_location();
		exit_direction();
		passage_width();
	} else {
		for (my $i = 0; $i < $exits; $i++) {
			exit_location();
		}
	}
	
	print "\n";
	
	room_contents();
	
}

sub unusual_room {

	my $rnd = random_number(20);
	
	print " is ";
	
	if ($rnd <= 5) {
		print "circular";
		my $pool = random_number(20);
		if ($pool <= 5) {
			pool();
		} elsif ($pool <= 7) {
			print " with well";
		} elsif ($pool <=	10) {
			print " with shaft";
		}
	} elsif ($rnd <= 8) {
		print "triangular";
	} elsif ($rnd <= 11) {
		print "trapezoidal";
	} elsif ($rnd <= 13) {
		print "odd-shaped (whatever fits the map/your choice)";
	} elsif ($rnd <= 15) {
		print "oval"
	} elsif ($rnd <= 17) {
		print "hexagonal"
	} elsif ($rnd <= 19) {
		print "octagonal";
	} else {
		print "a cave";
	}
	
	my $size = 0;
	
	my $fin = 0;
	while ($fin == 0) {
		
		$rnd = random_number(20);
		
		if ($rnd <= 3) {
			$size = $size + 500;
			$fin = 1;
		} elsif ($rnd <= 6) {
			$size = $size + 900;
			$fin = 1;
		} elsif ($rnd <= 8) {
			$size = $size + 1300;
			$fin = 1;
		} elsif ($rnd <= 10) {
			$size = $size + 2000;
			$fin = 1;
		} elsif ($rnd <= 12) {
			$size = $size + 2700;
			$fin = 1;
		} elsif ($rnd <= 14) {
			$size = $size + 3400;
			$fin = 1;
		} else {
			$size = $size + 2000;
		}
		
	}
	
	print " $size sq. ft.";
	
	print "\n";

}

# TABLE V.C.
sub exits {
	
	my $size = $_[0];
	my $rnd = random_number(20);
	my $exits = 0;
	
	print "\n";
	
	if ($rnd <= 3 and $size <= 600) {
		$exits = 1;
	} elsif ($rnd <= 3) {
		$exits = 3;
	} elsif ($rnd <= 6 and $size <= 600) {
		$exits = 2
	} elsif ($rnd <= 6) {
		$exits = 3;
	} elsif ($rnd <= 9 and $size <= 600) {
		$exits = 3;
	} elsif ($rnd <= 9) {
		$exits = 4;
	} elsif ($rnd <= 12 and $size <= 1200) {
		print "No exits, but there may be secret doors";
	} elsif ($rnd <= 12) {
		$exits = 1;
	} elsif ($rnd <= 15 and $size <= 1600) {
		print "No exits, but there may be secret doors";
	} elsif ($rnd <= 15) {
		$exits = 1;
	} elsif ($rnd <= 18) {
		$exits = random_number(4);
	} else {
		print "Exit is door if in chamber, passage if in room";
		$exits = -1;
	}
	
	return $exits	
}

# TABLE V.D.
sub exit_location {
	
	print "\n";
	
	my $rnd = random_number(20);
	
	if ($rnd <= 7) {
		print "Exit opposite wall";
	} elsif ($rnd <= 12) {
		print "Exit left wall";
	} elsif ($rnd <= 17) {
		print "Exit right wall";
	} else {
		print "Exit same wall.  If already mapped is ";
		my $secret_door = random_number(20);
		if ($secret_door <= 5) {
			print "a secret door";
		} elsif ($secret_door <= 10) {
			print "a one-way door";
		} else {
			print "in the opposite direction";
		}
	}

}

# TABLE V.E.
sub exit_direction() {
	
	my $rnd = random_number(20);
	
	print " passage ";
	
	if ($rnd <= 18) {
		print "straight ahead";
	} elsif ($rnd == 19) {
		print "45 degrees left/right (prefer left)";
	} else {
		print "45 degrees right/left (prefer right)";	
	}
	
	print "\n";
	
}

sub stairs() {
	
	my $rnd = random_number(20);
	
	my $chamber = 0;
	
	if ($rnd <= 5) {
		print "Stairs down 1 level";
		stairs_decision(1);
	} elsif ($rnd == 6) {
		print "Stairs down 2 levels";
		stairs_decision(2);
	} elsif ($rnd == 7) {
		print "Stairs down 3 levels";
		stairs_decision(3);
	} elsif ($rnd == 8) {
		print "Stairs up 1 level";
	} elsif ($rnd == 9) {
		print "Stairs up dead end";
		if (random_number(6) == 1) {
			print " with chute down 2 levels";	
		}
	} elsif ($rnd == 10) {
		print "Stairs down dead end";
		if (random_number(6) == 1) {
			print " with chute down 1 level";	
		}
	} elsif ($rnd == 11) {
		print "Chimney up one level, passage continues, check again in 30'";		
	} elsif ($rnd == 12) {
		print "Chimney up two levels, passage continues, check again in 30'";
	} elsif ($rnd == 13) {
		print "Chimney down two levels, passage continues, check again in 30'";
	} elsif ($rnd <= 16) {
		print "Trap door down one level, passage continues, check again in 30'";
	} elsif ($rnd == 17) {
		print "Trap door down 2 levels, passage continues, check again in 30'";
	} else {
		$chamber = 1;
		print "Stairs up 1 then down 2 levels (total down 1), chamber at end";
		print "\nDecide if you're going down to the chamber now\n";
		<STDIN>;
		chamber();
	}
	
	if ($chamber == 0) {
		print "\nUse passage from main menu to continue on new level\n";
	}
	
	print "\n";
}


sub trick_trap() {
	
	my $rnd = random_number(20);
	
	if ($rnd <= 5) {
		print "Secret door unless unlocated: non-elf locates 3 in 20, elf locates 5 in 20, magical device locates 18 in 20";
		print "\nIf located enter a 1 (and use 'Door' option from main menu to see what's behind it), otherwise press Enter\n";
		my $located = <STDIN>;
		chomp($located);
		if ($located ne "1") {
			print "Pit, 10' deep, 3 in 6 to fall in";
		}
	} elsif ($rnd <= 7) {
		print "Pit, 10' deep, 3 in 6 to fall in";
	} elsif ($rnd == 8) {
		print "Pit, 10' deep, with spikes, 3 in 6 to fall in";
	} elsif ($rnd == 9) {
		print "20' x 20' elevator room (party has entered door directly ahead and is in room), descends 1 level and will not ascend for 30 turns";
	} elsif ($rnd == 10) {
		print "20' x 20' elevator room (party has entered door directly ahead and is in room), descends 2 levels and will not ascend for 30 turns";
	} elsif ($rnd == 11) {
		print "20' x 20' elevator room (party has entered door directly ahead and is in room), descends 3 levels and will not ascend for 30 turns";
	} elsif ($rnd == 12) {
		my $turns = random_number(21) + 39;
		print "Wall 10' behind slides across passage blocking it for $turns turns";
	} elsif ($rnd == 13) {
		print "Oil (equal to one flask) pours on a random person from a hole in the ceiling, followed by flaming cinder (2-12 h.p. damage unless successful save vs. magic is made, which indicates only 1-3 h.p. damage";
	} elsif ($rnd == 14) {
		print "Pit, 10' deep, 3 in 6 to fall in, pit walls move together to crush victim in 2-5 rounds";
	} elsif ($rnd <= 16) {
		my $missile = "";
		if ($rnd == 15) {
			$missile = "arrow"
		} else {
			$missile = "spear"	
		}
		my $missiles = random_number(3);
		print "$missile trap, $missiles $missile" . "s";
		for (my $i = 0; $i < $missiles; $i++) {
			if (random_number(20) == 1) {
				print ", $missile " . ($i + 1) . " is poisoned";
			}	
		}
	} elsif ($rnd == 17) {
		print "Gas, party has detected it but must breathe it to continue along corridor, as it covers 60' ahead.\n";
		print "To go through gas now, enter 1, otherwise press Enter\n";
		my $gas = <STDIN>;
		chomp($gas);
		if ($gas eq "1") {
			gas();
		} else {
			print "Use 'gas' on main menu if you do pass through the gas at a later stage";	
		}
	} elsif ($rnd == 18) {
		print "Door falls outward causing 1-10 hit points, or stone falls from ceiling causing 2-20 points of damage to each person failing his saving throw versus petrification";
	} elsif ($rnd == 19) {
		print "Illusionary wall concealing ";
		my $wall_hides = random_number(20);
		if ($wall_hides <= 6) {
			print "Pit, 10' deep, with spikes, 3 in 6 to fall in";
		} elsif ($wall_hides <= 10) {
			print "Chute down 1 level (cannot be ascended in any manner)";
		} else {
			monster();
			treasure();
		}
	} else {
		print "Chute down 1 level (cannot be ascended in any manner)";
	}
	
	print "\n";
	
}

# TABLE VII.A. Gas Subtable
sub gas() {
	
	my $rnd = random_number(20);
	
	if ($rnd <= 7) {
		print "Only effect is to obscure vision";
	} elsif ($rnd <= 9) {
		print "Blinds for 1-6 Turns after passing through";
	} elsif ($rnd <= 12) {
		print "Fear: run back 120' unless saving throw versus magic is made";
	} elsif ($rnd == 13) {
		print "Sleep: party sound asleep for 2-12 turns (as sleep spell)";
	} elsif ($rnd <= 18) {
		print "Strength: adds 1-6 points of Strength (as Strength spell) to all fighters in party for 1-10 hours";
	} elsif ($rnd == 19) {
		print "Sickness: return to surface immediately";
	} else {
		print "Poison: killed unless a saving throw versus poison is made";
	}
	
	print "\n";
	
}

sub stairs_decision() {

	my $trick_chance = $_[0];
	my $plural = "";
	
	if ($trick_chance > 1) {
		$plural = "s";	
	}

	print "\nEnter 1 if you are going down now, otherwise press Enter\n";
	my $enter = <STDIN>;
	chomp $enter;
	if ($enter eq "1") {
		stairs_down($trick_chance);
	} else {
		print "Use 'Stairs down $trick_chance level$plural' on main menu when descending these stairs the first time";	
	}
	
	print "\n";

}

sub stairs_down() {

	my $trick_chance = $_[0];
	
	if (random_number(20) == $trick_chance) {
		print " have a door which closes behind you for a day!"
	} else {
		print "No trap/trick";
	}
	
	print "\n";
	
}

# TABLE V.F. Room Contents
sub room_contents() {
	
	my $rnd = random_number(20) + $empty_room_reducer;
	
	if ($rnd <= 12) {
		print "Empty";
	} elsif ($rnd <= 14) {
		monster();
	} elsif ($rnd <= 17) {
		monster();
		treasure();
	} elsif ($rnd == 18) {
		my $special = random_number(20);
		
		if ($special <= 5) {
			print "Stairway up one level";
		} elsif ($special <= 8) { 
			print "Stairway up two levels";
		} elsif ($special <= 14) { 
			print "Stairway down one level";
		} elsif ($special <= 19) { 
			print "Stairway down two levels";
		} else {
			print "Stairway down two levels followed by slanting passageway down 1 level (down 3 levels total)";
		}
		
	} elsif ($rnd == 19) {
		trick_trap();	
	} else {
		treasure();	
	}
	
	print "\n";
	
}

sub monster() {

	my $monster = random_number(8) + random_number(12);
	my ($num, $hit_dice, $xp_base, $xp_hp, $xp, $hit_points) = (0, 0, 0, 0, 0, 0);
	my $powerful_unique = "\nNote: Powerful, unique creatures such as demon princes, daemon masters and dukes of the hells will always be accompanied by a court of servants and vassals.  For example, Orcus will be found with undead, Titmat with abishai devils and several huge dragons, and Tnthraxus the Oinodaemon with lesser powerful daemons";

	print "Monster number " . $monster;
	print "\nCurrent Level? ";
	my $level = <STDIN>;
	chomp($level);

	# Monster Level I (from MM2, p. 133)	
	if ($level eq "1") {
		if ($monster == 2) {
			$num = random_number(4);
			print "$num Al-Mi'Raj (FF)";
		} elsif ($monster == 3) {
			$num = (random_number(6) + random_number(6));	
			print "$num Webbirds (MM2)";
		} elsif ($monster == 4) {
			$num = (random_number(6) + random_number(6) + random_number(6));
			print "$num Bullywugs (FF)";
		} elsif ($monster == 5) {
			$num = (random_number(6) + random_number(6));
			print "$num Pedipalps, Large (MM2)";
		} elsif ($monster == 6) {
			$num = random_number(3);
			print  $num . " Bowler";
			if ($num > 1) { print "s"; }
			print " (MM2)";
		} elsif ($monster == 7) {
			$num = random_number(4);
			print $num . " Bats, Giant (FF)";
		} elsif ($monster == 8) {
			$num = (random_number(4) + random_number(4) + random_number(4) + 3);
			print $num . " Goblins (MM1)";
		} elsif ($monster == 9) {
			$num = (random_number(6) + random_number(6) + 3);
			print $num . "Men, Bandit (MM1)";
		} elsif ($monster == 10) {
			$num = (random_number(10) + random_number(10));
			print "$num Bats (MM2)";
		} elsif ($monster == 11) {
			print "Character party rolled.  Could add autogenerate but for now rolling again\n";
			&monster();
		} elsif ($monster == 12) {
			$num = random_number(6) + 6;
			print $num . " Orcs (MM1)";
		} elsif ($monster == 13) {
			$num = random_number(4) + random_number(4) + random_number(4) + random_number(4) + random_number(4);
			print "$num Rats, Giant (MM1)";
		} elsif ($monster == 14) {
			$num = random_number(4) + random_number(4) + random_number(4) + 3;
			print "$num Kobolds (MM1)";
		} elsif ($monster == 15) {
			$num = random_number(4);
			print "$num Piercer";
			if ($num > 1) { print "s"; }
			print " (MM1)";
		} elsif ($monster == 16) {
			$num = random_number(4);
			print "$num Skeleton";
			if ($num > 1) { print "s"; }
			print " (MM1)";
		} elsif ($monster == 17) {
			$num = random_number(4) + random_number(4);
			print "$num Norkers (FF)";
		} elsif ($monster == 18) {
			$num = random_number(6) + random_number(6);
			print "$num Vulchings (MM2)";
		} elsif ($monster == 19) {
			$num = random_number(6) + random_number(6) + 3;
			print "$num Gnomes (MM1)";
		} elsif ($monster == 20) {
			$num = random_number(3);
			print "$num Demon";
			if ($num > 1) { print "s"; }
			print ", Nupperibo (MM2)";
		}
	# Monster Level II (from MM2, p. 133)
	} elsif ($level eq "2") {
		if ($monster == 2) {
			$num = random_number(6);
			print "$num Azer (MM2)";
		} elsif ($monster == 3) {
			$num = random_number(6) + random_number(6);
			print "$num Duergar";
		} elsif ($monster == 4) {
			$num = 1;
			print "$num Coffer Copse (FF)"
		} elsif ($monster == 5) {
			$num = 1;
			print "$num Gas Spore (MM1)";
		} elsif ($monster == 6) {
			$num = random_number(12);
			print "$num Lizard M";
			($num > 1) ? print "e" : print "a";
			print "n (MM1)";
		} elsif ($monster == 7) {
			$num = random_number(4) + random_number(4) + 2;
			print "$num Gnolls (MM1)";
		} elsif ($monster == 8) {
			$num = random_number(4) + random_number(4);
			print "$num Land Lampreys (MM2)";
		} elsif ($monster == 9) {
			$num = random_number(4) + random_number(4);
			print "$num Centipede, Giant (MM1)";
		} elsif ($monster == 10) {
			$num = random_number(4);
			print "$num Toad";
			if ($num > 1) {  print "s"; }
			print ", Giant (MM1)";
		} elsif ($monster == 11) {
			print "Character party rolled.  Could add autogenerate but for now rolling again\n";
			&monster();
		} elsif ($monster == 12) {
			$num = random_number(4) + random_number(4);
			print "$num Troglodytes (MM1)";
		} elsif ($monster == 13) {
			$num = random_number(6) + random_number(6) + random_number(6);
			print "$num Centipedes, Huge (MM2)";
		} elsif ($monster == 14) {
			$num = random_number(6) + random_number(6);
			print "$num Grimlocks (FF)";
		} elsif ($monster == 15) {
			$num = random_number(6) + random_number(6) + 3;
			print "$num Stirges (MM1)";
		} elsif ($monster == 16) {
			$num = random_number(6) + random_number(6);
			print "$num Mongrelmen";
		} elsif ($monster == 17) {
			$num = random_number(4) + random_number(4) + 2;
			print "$num Quaggoths (FF)";
		} elsif ($monster == 18) {
			$num = random_number(4) + random_number(4);
			print "$num Pedipalps, Huge (MM2)";
		} elsif ($monster == 19) {
			$num = random_number(6) + 1;
			print "$num Frogs, Killer (MM1)";
		} elsif ($monster == 20) {
			$num = random_number(4);
			print "$num Firebat";
			if ($num > 1) { print "s"; }
			print " (MM2)";
		}
	# Monster Level III (from MM2, p. 133)
	} elsif ($level == 3) {
		if ($monster == 2) {
			$num = 1;
			print "$num Leprechaun (MM1)";
		} elsif ($monster == 3) {
			$num = random_number(3);
			print "$num Mephit";
			if ($num > 1) { print "s"; }
			print ", ";
			if (random_number(2) == 1) {
				print "Fire";
			} else {
				print "Smoke";	
			}
			print " (FF)";
		} elsif ($monster == 4) {
			$num = 1;
			print "$num Phantom (MM2)";
		} elsif ($monster == 5) {
			$num = random_number(3);
			print "$num Ankheg";
			if ($num > 1) { print "s"; }
			print " (";
			if (random_number(2) == 1) {
				print "4";
			}
			print "HD) (MM1)";
		} elsif ($monster == 6) {
			$num = 1;
			print "$num Ochre Jelly (MM1)";
		} elsif ($monster == 7) {
			$num = random_number(4) + random_number(4);
			print "$num Kenku (FF)";
		} elsif ($monster == 8) {
			$num = 1;
			print "$num Luck Eater (MM2)";
		} elsif ($monster == 9) {
			print "Character party rolled.  Could add autogenerate but for now rolling again\n";
			&monster();
		} elsif ($monster == 10) {
			$num = random_number(4);
			print "$num Ogre";
			if ($num > 1) { print "s"; }
			print " (MM1)";
		} elsif ($monster == 11) {
			$num = random_number(4);
			print "$num Beetle";
			if ($num > 1) { print "s"; }
			print ", Giant Boring (MM1)";
		} elsif ($monster == 12) {
			$num = random_number(4);
			print "$num Spider";
			if ($num > 1) { print "s"; }
			print ", Large (MM1)";
		} elsif ($monster == 13) {
			$num = random_number(4);
			print "$num Scorpion";
			if ($num > 1) { print "s"; }
			print ", Large (MM2)";
		} elsif ($monster == 14) {
			$num = random_number(6) + 1;
			print "$num Bugbears (MM1)";
		} elsif ($monster == 15) {
			$num = 1;
			print "$num Gelatinous Cube (MM1)";
		} elsif ($monster == 16) {
			$num = random_number(3);
			print "$num Ustilagor (MM2)";
		} elsif ($monster == 17) {
			$num = random_number(3);
			print "$num Shocker";
			if ($num > 1) { print "s"; }
			print " (MM1)";
		} elsif ($monster == 18) {
			$num = random_number(4);
			print "$num Weasel";
			if ($num > 1) { print "s"; }
			print ", Giant (MM1)";
		} elsif ($monster == 19) {
			$num = random_number(2);
			print "$num Thoquaa (FF)";
		} elsif ($monster == 20) {
			$num = random_number(4) + random_number(4);
			print "$num Drow (FF)";
		}	
	# Monster Level IV (from MM2, p. 133)
	} elsif ($level eq "4") {
		if ($monster == 2)  {
			$num = random_number(6);
			print "$num Lava Child";
			if ($num > 1) { print "ren"; }	
			print " (FF)";
		} elsif ($monster == 3) {
			$num = random_number(4) + 1;
			print "$num Meenlocks (FF)";
		} elsif ($monster == 4) {
			$num = random_number(4) + 1;
			print "$num Hook Horrors (FF)";
		} elsif ($monster == 5) {
			$num = random_number(4) + random_number(4) + random_number(4);
			print "$num Pech (MM2)";
		} elsif ($monster == 6) {
			$num = random_number(2);
			print "$num Owlbear";
			if ($num > 1) { print "s"; }
		} elsif ($monster == 7) {
			$num = random_number(2);
			print "$num Rust Monster";
			if ($num > 1) { print "s"; }
			print " (MM1)";
		} elsif ($monster == 8) {
			$num = random_number(4);
			print "$num Pseudo-Undead, Ghast (MM2)";
		} elsif ($monster == 9) {
			print "Character party rolled.  Could add autogenerate but for now rolling again\n";
			&monster();
		} elsif ($monster == 10) {
			$num = 1;
			print "$num Yellow Mold (MM1)";
		} elsif ($monster == 11) {
			$num = random_number(6);
			print "$num Scorpion";
			if ($num > 1) { print "s"; }	
			print ", Huge (MM1)";
		} elsif ($monster == 12) {
			$num = random_number(4);
			print "$num Toad";
			if ($num > 1) { print "s"; }
			print ", Poisonous (MM1)";
		} elsif ($monster == 13) {
			$num = random_number(2);
			print "$num Gargoyle";
			if ($num > 1) { print "s"; }
			print " (MM1)";
		} elsif ($monster == 14) {
			$num = random_number(2);
			print "$num Hornet";
			if ($num > 1) { print "s"; }
			print ", Giant (FF)";
		} elsif ($monster == 15) {
			$num = 1;
			print "$num Hydra, ";
			(random_number(2)) ? print "5" : print "6";
			print "-headed (MM1)"
		} elsif ($monster == 16) {
			$num = random_number(4);
			print "$num Ghast";
			if ($num > 1) { print "s"; }
			print " (MM1)";
		} elsif ($monster == 17) {
			$num = 1;
			print "$num Caterwaul (MM1)";
		} elsif ($monster == 18) {
			$num = random_number(4);
			print "$num Solifugid";
			if ($num > 1) { print "s"; }	
			print ", Giant (MM2)";
		} elsif ($monster == 19) {
			$num = 1;
			print "$num Spectator (MM2)";	
		} elsif ($monster == 20) {
			$num = random_number(4);
			print "$num Githyanki (FF)";
		}
	# Monster Level V (from MM2, p. 133)
	} elsif ($level eq "5") {
		if ($monster == 2) {
			$num = 1;
			print "$num Grue, Chaggrin (MM2)";
		} elsif ($monster == 3) {
			$num = 1;
			print "$num Cloaker (MM2)";
		} elsif ($monster == 4) {
			$num = random_number(2);
			print "$num Algoid";
			if ($num > 1) { print "s"; }
			print " (FF)";
		} elsif ($monster == 5) {
			$num = random_number(4);
			print "$num Phycomid";
			if ($num > 1) { print "s"; }
			print " (MM2)";
		} elsif ($monster == 6) {
			$num = random_number(3);
			print "$num Minotaur";
			if ($num > 1) { print "s"; }
			print " (MM1)";
		} elsif ($monster == 7) {
			$num = random_number(3);
			print "$num Snake";
			if ($num > 1) { print "s"; }
			print ", Giant Poisonous (MM2)";
		} elsif ($monster == 8) {
			$num = random_number(3);
			print "$num Lizard";
			if ($num > 1) { print "s"; }
			print ", Subterranean (MM1)";
		} elsif ($monster == 9) {
			$num = random_number(2);
			print "$num Bear";
			if ($num > 1) { print "s"; }
			print ", Cave (MM1)";
		} elsif ($monster == 10) {
			print "Character party rolled.  Could add autogenerate but for now rolling again\n";
			&monster();
		} elsif ($monster == 11) {
			$num = random_number(2);
			print "$num Cockatrice (MM1)";
		} elsif ($monster == 12) {
			$num = random_number(4);
			print "$num Spider";
			if ($num > 1) { print "s"; }
			print ", Giant (MM1)";
		} elsif ($monster == 13) {
			$num = random_number(4) + 1;
			print "$num Giants, Verbeeg (MM2)";
		} elsif ($monster == 14) {
			$num = 1;
			print "$num 7-headed Hydra (MM1)";
		} elsif ($monster == 15) {
			$num = random_number(4) + 1;
			print "$num Snakes, Poisonous (MM2)";
		} elsif ($monster == 16) {
			$num = random_number(2);
			print "$num Margoyle";
			if ($num > 1) { print "s"; }
			print " (MM2)";
		} elsif ($monster == 17) {
			$num = random_number(2);
			print "$num Rock Reptile";
			if ($num > 1) { print "s"; }
			print " (MM2)";
		} elsif ($monster == 18) {
			$num = random_number(3);
			print "$num Doppleganger";
			if ($num > 1) { print "s"; }
			print " (MM1)";
		} elsif ($monster == 19) {
			$num = random_number(3);
			print "$num Solifugid";
			if ($num > 1) { print "s"; }
			print ", Giant (MM2)";
		} elsif ($monster == 20) {
			$num = 1;
			print "$num Pyro-Hydra (5-heads) ";
			if ($num > 1) { print "s"; }
			print " (MM1)";
		}
	# Monster Level VI (from MM2, p. 133)
	} elsif ($level eq "6") {
		if ($monster == 2) {
			$num = random_number(3);
			print "$num Drider";
			if ($num > 1) { print "s"; }
			print " (MM2)";
		} elsif ($monster == 3) {
			$num = 1;
			print "$num Rakshasa (MM1)";
		} elsif ($monster == 4) {
			$num = 1;
			print "$num Green Slime (MM1)";
		} elsif ($monster == 5) {
			$num = 1;
			print "$num Basiliks (MM1)";
		} elsif ($monster == 6) {
			$num = 1;
			print "$num Grell (FF)";
		} elsif ($monster == 7) {
			$num = 1;
			print "$num Otyugh (MM1)";
		} elsif ($monster == 8) {
			$num = 1;
			print "$num Wyvern";
		} elsif ($monster == 9) {
			$num = random_number(2);
			print "$num Wraith";
			if ($num > 1) { print "s"; }
			print " (MM1)";
		} elsif ($monster == 10) {
			$num = random_number(4);
			print "$num Wight";
			if ($num > 1) { print "s"; }
			print " (MM1)";
		} elsif ($monster == 11) {
			print "Character party rolled.  Could add autogenerate but for now rolling again\n";
			&monster();
		} elsif ($monster == 12) {
			$num = random_number(2);
			print "$num Pseudowraith";
			if ($num > 1) { print "s"; }
			print " (MM2)";
		} elsif ($monster == 13) {
			$num = random_number(2);
			print "$num Carrion Crawler";
			if ($num > 1) { print "s"; }
			print " (MM1)";
		} elsif ($monster == 14) {
			$num = random_number(2);
			print "$num Scorpion";
			if ($num > 1) { print "s"; }
			print ", Giant (MM1)";
		} elsif ($monster == 15) {
			$num = random_number(3);
			print "$num Troll";
			if ($num > 1) { print "s"; }
			print " (MM1)";
		} elsif ($monster == 16) {
			$num = random_number(2);
			print "$num Devil";
			if ($num > 1) { print "s"; }
			print ", Abishai (MM2)";
		} elsif ($monster == 17) {
			$num = 1;
			print "$num Dragon, Black, Old (MM1)";
		} elsif ($monster == 18) {
			$num = random_number(2);
			print "$num Oger Mage";
			if ($num > 1) { print "s"; }
			print " (MM1)";
		} elsif ($monster == 19) {
			$num = random_number(3);
			print "$num Yuan-Ti (MM2)";
		} elsif ($monster == 20) {
			$num = 1;
			print "$num Slaad, Red (FF)";
		}
	# Level 7
	} elsif ($level eq "7") {
		if ($monster == 2) {
			$num = 1;
			print "$num Dao (MM2)";
		}
		if ($monster == 3) {
			$num = 1;
			print "$num Basilisk, Greater (MM2)";
		}
		if ($monster == 4) {
			$num = 1;
			print "$num Umber Hulk";
		}
		if ($monster == 5) {
			$num = 1;
			print "$num Mimic (MM1)";
		}
		if ($monster == 6) {
			$num = 1;
			print "$num Chimera (MM1)";
		}
		if ($monster == 7) {
			$num = 1;
			print "$num Lurker Above (MM1)";
		} elsif ($monster == 8) {
			$num = random_number(3);
			print "$num ";
			(random_number(2)) ? print "Frost" : print "Fire";
			print " Giant";
			if ($num > 1) { print "s"; }
			print " (MM1)";
		} elsif ($monster == 9) {
			print "Character party rolled.  Could add autogenerate but for now rolling again\n";
			&monster();
		} elsif ($monster == 10) {
			$num = 1;
			print "$num Pudding, Black";
		} elsif ($monster == 11) {
			$num = random_number(4);
			print "$num Hill Giant";
			if ($num > 1) { print "s"; }
			print " (MM1)";
		} elsif ($monster == 12) {
			$num = random_number(3);
			print "$num Will-O-Wisp";
			if ($num > 1) { print "s"; }
			print " (MM1)";
		} elsif ($monster == 13) {
			$num = 1;
			print "$num Slug, Giant";
		} elsif ($monster == 14) {
			$num = random_number(2);
			print "$num Psuedospectre";
			if ($num > 1) { print "s"; }
			print "s (MM2)";
		} elsif ($monster == 15) {
			$num = 1;
			print "$num Sundew, Giant";
		} elsif ($monster == 16) {
			$num = random_number(2);
			print "$num Mumm";
			($num > 1) ? print "ies" : print "y";
			print " (MM1)";
		} elsif ($monster == 17) {
			$num = 1;
			print "$num Spectre (MM1)";
		} elsif ($monster == 18) {
			$num = 1;
			print "$num Invisible Stalker (MM1)";
		} elsif ($monster == 19) {
			$num = random_number(4);
			print "$num Diakk";
			if ($num > 1) { print "s"; }
			print " (MM2)";
		} elsif ($monster == 20) {
			$num = 1;
			print "$num Daemon, Mezzo- (FF)";
		}
	# Monster Level VIII (from MM2, p. 134)
	} elsif ($level eq "8") {
		if ($monster == 2) {
			$num = 1;
			print "$num Foo Lion (MM2)";
		} elsif ($monster == 3) {
			$num = 1;
			print "$num Xag-Ya (MM2)";
		} elsif ($monster == 4) {
			$num = random_number(2);
			print "$num Demon";
			if ($num > 1) { print "s"; }
			print ", Chasme";
		} elsif ($monster == 5) {
			$num = random_number(2);
			print "$num Aurumvorax";
		} elsif ($monster == 6) {
			$num = 1;
			print "$num Vampire (MM1)";
		} elsif ($monster == 7) {
			$num = 1;
			print "$num Pudding, Deadly Brown (MM1)";
		} elsif ($monster == 8) {
			$num = random_number(2);
			print "$num Demon";
			if ($num > 1) { print "s"; }
			print ", Alu-";
		} elsif ($monster == 9) {
			print "Character party rolled.  Could add autogenerate but for now rolling again\n";
			&monster();
		} elsif ($monster == 10) {
			$num = 1;
			my $heads = random_number(4) + 12;
			print "$num $heads-headed Hydra (MM1)";
			print "\n8 hit points per head, all fought individually - hydra not dead until they are all dead";
			treasure_type("b");
			$hit_dice = $heads;
		} elsif ($monster == 11) {
			$num = random_number(2);
			print "$num Psudeovampire";
			if ($num > 1) { print "s"; }
			print " (MM2)";
		} elsif ($monster == 12) {
			$num = random_number(2);
			print "$num Rust Monster";
			if ($num > 1) { print "s"; }
			print " (MM1)";
		} elsif ($monster == 13) {
			$num = 1;
			print "$num Will-O-Wisp";
		} elsif ($monster == 14) {
			$num = 1;
			print "$num Trapper";
		} elsif ($monster == 15) {
			$num = 1;
			print "$num Type V Demon (MM1)";
		} elsif ($monster == 16) {
			$num = 1;
			print "$num Purple Worm (MM1)";
		} elsif ($monster == 17) {
			$num = 1;
			print "$num Ghost (MM1)";
		} elsif ($monster == 18) {
			$num = 1;
			print "$num Dragon, Ancient, Black (MM1)";
		} elsif ($monster == 19) {
			$num = 1;
			print "$num Xeg-Yi (MM2)";
			$hit_dice = random_number(4) + 4;
			$xp_base = 1100;
			$xp_hp = 10;
		} elsif ($monster == 20) {
			$num = 1;
			print "$num Daemon, Charona- (MM2)";
		}
	# Monster Level IX (from MM2, p. 134)
	} elsif ($level eq "9") {
		if ($monster == 2) {
			$num = 1;
			print "$num Demon, Type VI (MM1)";
		} elsif ($monster == 3) {
			$num = 1;
			print "$num Deva, Monadic (MM2)";
		} elsif ($monster == 4) {
			$num = 1;
			print "$num Devil, Pit Fiend (MM1)";
		} elsif ($monster == 5) {
			$num = 1;
			print "$num Dragon, Red, Ancient (MM1)";
		} elsif ($monster == 6) {
			$num = 1;
			print "$num Hydra, Pyro- (12 Heads) (MM1)";
		} elsif ($monster == 7) {
			$num = 1;
			print "$num Slaad, Grey (FF)";
		} elsif ($monster == 8) {
			$num = 1;
			print "$num Titan, Minor (MM1)";
		} elsif ($monster == 9) {
			print "Character party rolled.  Could add autogenerate but for now rolling again\n";
			&monster();
		} elsif ($monster == 10) {
			$num = 1;
			print "$num Deva, Movanic (MM2)";
		} elsif ($monster == 11) {
			$num = 1;
			print "$num Thessalhydra (MM2)";
		} elsif ($monster == 12) {
			$num = 1;
			print "$num Vampire, Former Cleric, Level " . (random_number(4) + 6);
		} elsif ($monster == 13) {
			$num = 1;
			print "$num Golem, Stone (MM1)";
		} elsif ($monster == 14) {
			$num = 2;
			print "$num Black Dragons, Ancient and Old (MM1)";
		} elsif ($monster == 15) {
			$num = random_number(2);
			print "$num Demodand";
			if ($num > 1) { print "s"; }
			print ", Kelubar (MM2)";
		} elsif ($monster == 16) {
			$num = 1;
			print "$num Daemon, Nyca- (FF)";
		} elsif ($monster == 17) {
			$num = 1;
			print "$num Titan, Major (MM1)";
		} elsif ($monster == 18) {
			$num = 1;
			print "$num Baku (MM2)";
		} elsif ($monster == 19) {
			$num = 1;
			print "$num Daemon, Ultro- (MM2)";
		} elsif ($monster == 20) {
			$num = 1;
			print "$num Demilich (MM2)";
		}
	# Monster Level X (from MM2, p. 134)
	} elsif ($level eq "10") {
		if ($monster == 2) {
			$num = 1;
			print "$num Demon Prince (ALL)";
			print $powerful_unique;
		} elsif ($monster == 3) {
			$num = 1;
			print "$num Elemental Prince of Evil (FF)";
			print $powerful_unique;
		} elsif ($monster == 4) {
			$num = 1;
			print "$num Modron, Quarton (MM2)";
		} elsif ($monster == 5) {
			$num = 1;
			print "$num Tarrasque (MM2)";
		} elsif ($monster == 6) {
			$num = 2;
			print "$num Dragons, Red, Ancient and Very Old (MM1)";
		} elsif ($monster == 7) {
			$num = 2;
			print "$num Dragons, Blue, Ancient and Very Old (MM1)";
		} elsif ($monster == 8) {
			$num = 1;
			print "$num Solar (MM2)";
		} elsif ($monster == 9) {
			$num = 1;
			print "$num Golem, Iron (MM1)";
		} elsif ($monster == 10) {
			$num = 1;
			print "$num Planetar (MM2)";
		} elsif ($monster == 11) {
			$num = 1;
			print "$num Slaad, Death (FF)";
		} elsif ($monster == 12) {
			$num = 1;
			print "$num Beholder (MM1)";
		} elsif ($monster == 13) {
			print "Character party rolled.  Could add autogenerate but for now rolling again\n";
			&monster();
		} elsif ($monster == 14) {
			$num = 1;
			print "$num Lich (MM1)";
		} elsif ($monster == 15) {
			$num = 1;
			print "$num Vampire, Former Magic-User, Level " . (random_number(8) + 4);
			print " (MM1)";
		} elsif ($monster == 16) {
			$num = 1;
			print "$num Dragon, Cloud, Ancient (MM2)";
		} elsif ($monster == 17) {
			$num = 1;
			print "$num Modron, Quinton (MM2)";
		} elsif ($monster == 18) {
			$num = 1;
			print "$num Titan, Elder (MM1)";
		} elsif ($monster == 19) {
			$num = 1;
			print "$num Daemon, Charon (MM2)";
			print $powerful_unique;
		} elsif ($monster == 20) {
			$num = 1;
			print "$num Devil, Duke or Arch- (ALL)";
			print $powerful_unique;
		}
	}

	print "\n";

	my $thac0 = 21 - $hit_dice;
	# % is Modulus
	if (($thac0 % 2) == 0) {
		$thac0 = $thac0 - 1;
	}
	print "THAC0: $thac0\n";

	$hit_points = 0;
	$xp = 0;
	for (my $j = 0; $j < $num; $j++) {
		$hit_points = 0;
		for (my $i = 0; $i < $hit_dice; $i++) {
			$hit_points = $hit_points + random_number(8);
		}
		$xp = $xp_base + ($hit_points * $xp_hp);
		print "Hit Points: $hit_points ($hit_dice HD)\n";
	}

	print "Experience Points: $xp\n";
	

}

sub treasure() {

	my $rnd = random_number(100);
	
	if ($rnd <= 25) {
		print "1000 copper pieces/level";
	} elsif ($rnd <= 50) {
		print "1000 silver pieces/level";
	} elsif ($rnd <= 65) {
		print "750 electrum pieces/level";
	} elsif ($rnd <= 80) {
		print "250 gold pieces/level";
	} elsif ($rnd <= 90) {
		print "100 platinum pieces/level";
	} elsif ($rnd <= 94) {
		print random_number(4) . " gems/level";
		gem();
	} elsif ($rnd <= 97) {
		print "1 piece of jewelry/level";
		jewelry();
	} else {
		print "Magic - roll once on Magic Items table";
	}
	
	# TABLE V.H. Treasure Is Contained In
	$rnd = random_number(20);
	
	if ($rnd <= 2) {
		print " in bags";
	} elsif ($rnd <= 4) {
		print " in sacks";
	} elsif ($rnd <= 6) {
		print " in small coffers";
	} elsif ($rnd <= 8) {
		print " in chests";
	} elsif ($rnd <= 10) {
		print " in huge chests";
	} elsif ($rnd <= 12) {
		print " in pottery jars";
	} elsif ($rnd <= 14) {
		print " in metal urns";
	} elsif ($rnd <= 16) {
		print " in stone containers";
	} elsif ($rnd <= 18) {
		print " in iron trunks";
	} else {
		print " loose";
	}
	
	
	# TABLE V.I. Footnote
	$rnd = random_number(20);
	
	if ($rnd <= 8) {
		treasure_guarded_by();
	} else {
		treasure_hidden_by();
	}
	
	print "\n";
	
}

sub treasure_guarded_by() {
	
	my $rnd = random_number(20);
	
	if ($rnd <= 2) {
		print " contact poison on container";
	} elsif ($rnd <= 4) {
		print " contact poision on treasure";
	} elsif ($rnd <= 6) {
		print " poisoned needles in lock";
	} elsif ($rnd == 7) {
		print " poisoned needles in handles";
	} elsif ($rnd == 8) {
		print " spring darts firing from front of container";
	} elsif ($rnd == 9) {
		print " spring darts firing up from top of container";
	} elsif ($rnd == 10) {
		print " spring darts firing up from inside bottom of container";
	} elsif ($rnd <= 12) {
		print " blade scything across inside";
	} elsif ($rnd == 13) {
		print " poisonous insects or reptiles living inside container";
	} elsif ($rnd == 14) {
		print " gas released by opening container.  ";
		gas();
	} elsif ($rnd == 15) {
		print " trapdoor opening in front of container";
	} elsif ($rnd == 16) {
		print " trapdoor opening 6' in front of container";
	} elsif ($rnd == 17) {
		print " stone block dropping in front";
	} elsif ($rnd == 18) {
		print " spears released from walls when container opened";
	} elsif ($rnd == 19) {
		print " Explosive Runes (spell)";
	} else {
		print " Symbol (spell)";
	}
		
}

sub treasure_hidden_by() {
	
	my $rnd = random_number(20);
	
	if ($rnd <= 3) {
		print " invisibility (spell)";
	} elsif ($rnd <= 5) {
		print " illusion (spell) to change or hide appearance";
	} elsif ($rnd == 6) {
		print " secret space under container";
	} elsif ($rnd <= 8) {
		print " secret compartment in container";
	} elsif ($rnd == 9) {
		print " inside ordinary item in plain view";
	} elsif ($rnd == 10) {
		print " disguised to appear as something else";
	} elsif ($rnd == 11) {
		print " under a heap of trash/dung";
	} elsif ($rnd <= 13) {
		print " under a loose stone in the floor";
	} elsif ($rnd <= 15) {
		print " behind a loose stone in the wall";
	} else {
		print " in a secret room nearby";	
	}
}

sub jewelry() {
	
	my $rnd = random_number(100);
	my $value = 0;
	my $gems = 0;
	
	if ($rnd <= 10) {
		$value = random_number(10) * 100;
	} elsif ($rnd <= 20) {
		$value = (random_number(6) + random_number(6)) * 100;
	} elsif ($rnd <= 40) {
		$value = (random_number(6) + random_number(6) + random_number(6)) * 100;
	} elsif ($rnd <= 50) {
		$value = (random_number(6) + random_number(6) + random_number(6) + random_number(6) + random_number(6)) * 100;
	} elsif ($rnd <= 70) {
		$gems = 1;
		$value = random_number(6) * 1000;
	} elsif ($rnd <= 90) {
		$gems = 1;
		$value = (random_number(4) + random_number(4)) * 1000;
	} else {
		$gems = 1;
		$value = (random_number(6) + random_number(6)) * 1000;
	}
	
	until (random_number(10) != 1) {
		print "Exceptional quality - increase to next class (can happen multiple times)";
	}
	
	if ($gems == 1) {
		if (random_number(8) == 1) {
			print "Exceptional gem worth 5000gp";
			until (random_number(6) != 1) {
				print "supra-exceptional, double value (can happen multiple times to a maximum of 640,000gp)";	
			}
		}	
	}
	
	print " value of $value";	
}


sub gem() {
	
	my $value = 0;
	my $rnd = random_number(100);
	
	if ($rnd <= 25) {
		$value = 10;
	} elsif ($rnd <= 50) {
		$value = 50;
	} elsif ($rnd <= 70) {
		$value = 100;
	} elsif ($rnd <= 90) {
		$value = 500;
	} elsif ($rnd <= 99) {
		$value = 1000;
	} else {
		$value = 5000;
	}
	
	print " value of $value";
}

sub river {
	
	my $river = random_number(20);
	
	if ($river <= 10) {
		print " with a bridge";
	} elsif ($river <= 15) {
		print " with a boat";
		if (random_number(2) == 1) {
			print " on this bank";
		} else {
			print " on the other bank";
		}
	} else {
		print " with no bridge or boat";
	}	
}

sub pool {

	my $rnd = random_number(20);
	
	print "pool not implemented yet!  back to the book!";
		
}

sub treasure_type {

	my $tt = uc($_[0]);
	my ($copper_chance, $copper_amount, $silver_chance, $silver_amount, $electrum_chance, $electrum_amount, $gold_chance, $gold_amount, $platinum_chance, $platinum_amount, $gems_chance, $gems_amount, $jewelry_chance, $jewelry_amount, $magic_chance, $magic_amount) = (0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);

	print "Treasure Type $tt:\n";
	
	if ($tt eq "A") {
		$copper_chance = 25;
		$copper_amount = random_number(6) * 1000;
		$silver_chance = 30;
		$silver_amount = random_number(6) * 1000;
		$electrum_chance = 35;
		$electrum_amount = random_number(6) * 1000;
		$gold_chance = 40;
		$gold_amount = random_number(10) * 1000;
		$platinum_chance = 25;
		$platinum_amount = random_number(4) * 100;
		$gems_chance = 60;
		$gems_amount = random_number(10) + random_number(10) + random_number(10) + random_number(10);
		$jewelry_chance = 50;
		$jewelry_amount = random_number(10) + random_number(10) + random_number(10);
		$magic_chance = 30;
		$magic_amount = "Any 3";
	}
	
	if ($tt eq "B") {
		$copper_chance = 50;
		$copper_amount = random_number(8) * 1000;
		$silver_chance = 25;
		$silver_amount = random_number(6) * 1000;
		$electrum_chance = 25;
		$electrum_amount = random_number(4) * 1000;
		$gold_chance = 25;
		$gold_amount = random_number(3) * 1000;
		$platinum_chance = 0;
		$platinum_amount = 0;
		$gems_chance = 30;
		$gems_amount = random_number(8);
		$jewelry_chance = 20;
		$jewelry_amount = random_number(4);
		$magic_chance = 10;
		$magic_amount = "Sword, Armour or Miscellaneous Weapon";
	}
	
	if ($tt eq "C") {
		$copper_chance = 20;
		$copper_amount = random_number(12) * 1000;
		$silver_chance = 30;
		$silver_amount = random_number(6) * 1000;
		$electrum_chance = 10;
		$electrum_amount = random_number(4) * 1000;
		$gold_chance = 0;
		$gold_amount = 0;
		$platinum_chance = 0;
		$platinum_amount = 0;
		$gems_chance = 25;
		$gems_amount = random_number(6);
		$jewelry_chance = 20;
		$jewelry_amount = random_number(3);
		$magic_chance = 10;
		$magic_amount = "Any 2";
	}
	
	if ($tt eq "D") {
		$copper_chance = 10;
		$copper_amount = random_number(8) * 1000;
		$silver_chance = 15;
		$silver_amount = random_number(12) * 1000;
		$electrum_chance = 15;
		$electrum_amount = random_number(8) * 1000;
		$gold_chance = 50;
		$gold_amount = random_number(6) * 1000;
		$platinum_chance = 0;
		$platinum_amount = 0;
		$gems_chance = 30;
		$gems_amount = random_number(10);
		$jewelry_chance = 25;
		$jewelry_amount = random_number(6);
		$magic_chance = 15;
		$magic_amount = "Any 2 plus 1 potion";
	}
	
	if ($tt eq "E") {
		$copper_chance = 5;
		$copper_amount = random_number(10) * 1000;
		$silver_chance = 25;
		$silver_amount = random_number(12) * 1000;
		$electrum_chance = 25;
		$electrum_amount = random_number(6) * 1000;
		$gold_chance = 25;
		$gold_amount = random_number(8) * 1000;
		$platinum_chance = 0;
		$platinum_amount = 0;
		$gems_chance = 15;
		$gems_amount = random_number(12);
		$jewelry_chance = 10;
		$jewelry_amount = random_number(8);
		$magic_chance = 25;
		$magic_amount = "Any 3 plus 1 scroll";	
	}
		
	if ($tt eq "F") {
		$copper_chance = 0;
		$copper_amount = 0;
		$silver_chance = 10;
		$silver_amount = random_number(20) * 1000;
		$electrum_chance = 15;
		$electrum_amount = random_number(12) * 1000;
		$gold_chance = 40;
		$gold_amount = random_number(10) * 1000;
		$platinum_chance = 35;
		$platinum_amount = random_number(8) * 100;
		$gems_chance = 20;
		$gems_amount = random_number(10) + random_number(10) + random_number(10);
		$jewelry_chance = 10;
		$jewelry_amount = random_number(10);
		$magic_chance = 30;
		$magic_amount = "Any 3 except swords or misc. weapons, plus 1 potion and 1 scroll";	
	}
	
	if ($tt eq "G") {
		$copper_chance = 0;
		$copper_amount = 0;
		$silver_chance = 0;
		$silver_amount = 0;
		$electrum_chance = 0;
		$electrum_amount = 0;
		$gold_chance = 50;
		$gold_amount = random_number(4) * 10000;
		$platinum_chance = 50;
		$platinum_amount = random_number(20) * 100;
		$gems_chance = 30;
		$gems_amount = random_number(4) + random_number(4) + random_number(4) + random_number(4) + random_number(4);
		$jewelry_chance = 25;
		$jewelry_amount = random_number(10);
		$magic_chance = 35;
		$magic_amount = "Any 4 plus 1 scroll";			
	}
	
	if ($tt eq "H") {
		$copper_chance = 25;
		$copper_amount = (random_number(6) + random_number(6) + random_number(6) + random_number(6) + random_number(6)) * 1000;
		$silver_chance = 40;
		$silver_amount = random_number(100) * 1000;
		$electrum_chance = 40;
		$electrum_amount = random_number(4) * 10000 ;
		$gold_chance = 55;
		$gold_amount = random_number(6) * 10000;
		$platinum_chance = 25;
		$platinum_amount = (random_number(10) + random_number(10) + random_number(10) + random_number(10) + random_number(10)) * 100;
		$gems_chance = 50;
		$gems_amount = random_number(100);
		$jewelry_chance = 50;
		$jewelry_amount = random_number(4) * 10;
		$magic_chance = 15;
		$magic_amount = "Any 4 plus 1 potion and 1 scroll";	
	}
	
	if ($tt eq "I") {
		$copper_chance = 0;
		$copper_amount = 0;
		$silver_chance = 0;
		$silver_amount = 0;
		$electrum_chance = 0;
		$electrum_amount = 0;
		$gold_chance = 0;
		$gold_amount = 0;
		$platinum_chance = 30;
		$platinum_amount = (random_number(6) + random_number(6) + random_number(6)) * 100;
		$gems_chance = 55;
		$gems_amount = random_number(10) + random_number(10);
		$jewelry_chance = 50;
		$jewelry_amount = random_number(12);
		$magic_chance = 15;
		$magic_amount = "Any 1";
	}
	
	if ($tt eq "J") {
		$copper_chance = 100;
		$copper_amount = random_number(8) + random_number(8) + random_number(8);
	}
	
	if ($tt eq "K") {
		$silver_chance = 100;
		$silver_amount = random_number(6) + random_number(6) + random_number(6);
	}
	
	if ($tt eq "L") {
		$electrum_chance = 100;
		$electrum_amount = random_number(6) + random_number(6);
	}
	
	if ($tt eq "M") {
		$gold_chance = 100;
		$gold_amount = 	random_number(4) + random_number(4);
	}
	
	if ($tt eq "N") {
		$platinum_chance = 100;
		$platinum_amount = random_number(6);	
	}
	
	if ($tt eq "O") {
		$copper_chance = 25;
		$copper_amount = random_number(4) * 1000;
		$silver_chance = 20;
		$silver_amount = random_number(3) * 1000;	
	}
	
	if ($tt eq "P") {
		$silver_chance = 30;
		$silver_amount = random_number(6) * 1000;
		$electrum_chance = 25;
		$electrum_amount = random_number(2) * 1000;
	}
	
	if ($tt eq "Q") {
		$gems_chance = 50;
		$gems_amount = random_number(4);	
	}
	
	if ($tt eq "R") {
		$gold_chance = 40;
		$gold_amount = random_number(4) + random_number(4);
		$platinum_chance = 50;
		$platinum_amount = random_number(6) * 1000;
		$gems_chance = 55;
		$gems_amount = random_number(8) + random_number(8) + random_number(8) + random_number(8);
		$jewelry_chance = 45;
		$jewelry_amount = random_number(12);
	}
	
	if ($tt eq "S") {
		$magic_chance = 40;
		$magic_amount = (random_number(4) + random_number(4)) . " potions";
	}
	
	if ($tt eq "T") {
		$magic_chance = 50;
		$magic_amount = random_number(4) . " scrolls";	
	}
	
	if ($tt eq "U") {
		$gems_chance = 90;
		$gems_amount = ((random_number(8)) * 10);
		$jewelry_chance = 80;
		$jewelry_amount = random_number(6) + random_number(6) + random_number(6) + random_number(6) + random_number(6);
		$magic_chance = 70;
		$magic_amount = "1 of each magic excluding potions and scrolls";
	}
	
	if ($tt eq "V") {
		$magic_chance = 85;
		$magic_amount = "2 of each magic excluding potions and scrolls";	
	}
	
	if ($tt eq "W") {
		$gold_chance = 60;
		$gold_amount = (random_number(6) + random_number(6) + random_number(6) + random_number(6) + random_number(6)) * 1000;
		$platinum_chance = 15;
		$platinum_amount = random_number(8) * 100;
		$gems_chance = 60;
		$gems_amount = random_number(8) * 10;
		$jewelry_chance = 50;
		$jewelry_amount = random_number(8) + random_number(8) + random_number(8) + random_number(8) + random_number(8);
		$magic_chance = 55;
		$magic_amount = "1 map";
	}
	
	if ($tt eq "X") {
		$magic_chance = 60;
		$magic_amount = "1 misc. magic plus 1 potion";	
	}
	
	if ($tt eq "Y") {
		$gold_chance = 70;
		$gold_amount = (random_number(6) + random_number(6)) * 1000
	}
	
	if ($tt eq "Z") {
		$copper_chance = 20;
		$copper_amount = random_number(4) * 1000;
		$silver_chance = 25;
		$silver_amount = random_number(4) * 1000;
		$electrum_chance = 25;
		$electrum_amount = random_number(4) * 1000;
		$gold_chance = 30;
		$gold_amount = random_number(4) * 1000;
		$platinum_chance = 30;
		$platinum_amount = random_number(6) * 100;
		$gems_chance = 55;
		$gems_amount = random_number(6) * 10;
		$jewelry_chance = 50;
		$jewelry_amount = random_number(6) + random_number(6) + random_number(6) + random_number(6) + random_number(6);
		$magic_chance = 50;
		$magic_amount = "Any 3";
	}
	
	
	
	
	if (random_number(100) <= $copper_chance) {
		print $copper_amount . " copper pieces\n";
	}
	if (random_number(100) <= $silver_chance) {
		print $silver_amount . " silver pieces\n";	
	}
	if (random_number(100) <= $electrum_chance) {
		print $electrum_amount . " electrum pieces\n";
	}
	if (random_number(100) <= $gold_chance) {
		print $gold_amount . " gold pieces\n";	
	}
	if (random_number(100) <= $platinum_chance) {
		print $platinum_amount . " platinum pieces\n";	
	}
	if (random_number(100) <= $gems_chance) {
		print $gems_amount . " gems with ";
		gem();
		print "\n";
	}
	if (random_number(100) <= $gems_chance) {
		print $gems_amount . " jewelry with ";
		jewelry();
		print "\n";
	}
	if (random_number(100) <= $magic_chance) {
		print "*** Magic Items: " . $magic_amount . " ***\n";
	}
	
}


sub die_roller() {

	my @chars;
	my $ch = "";
	my $doing = "";
	my $num_dice;
	my $curr;
	my $sofar = 0;
	my $total;
	
	# command-line die roller: its quicker this way!
	
#	print "\n DICE ROLLER\n\n";
#	print "   Input is xdx with optional +x or -x (no spaces) \n";
#	print "   where x are integers - any other input will \n";
#	print "   produce invalid output\n";
#	print "\n   e.g.\n\n   4d6 \n   or \n   3d4+2 \n   or \n   1d6-1\n";
#	print "\n   Up cursor key retrieves past input\n\n";
	
	# when enter is pressed
		
	$doing = "";
	$curr = "";
	$num_dice = 0;
		
	# Its been chomped above so its unchomped here before being split
	@chars = split "", ($_[0] . "\n");
		
	# chop up command into dice types, number of dice and modifiers
	# step through chars
	for (my $i = 0; $i < @chars; $i++) {
		$ch = $chars[$i];
		
		if ($ch eq "d") {
			$doing = "sides";
			$num_dice = $curr;
			$curr = "";
		} elsif ($ch eq "-") {
			$doing = "minus";
			$sofar = roll_dice($num_dice, $curr);
			$curr = "";
			$num_dice = 0;
		} elsif ($ch eq "+") {
			$doing = "plus";
			$sofar = roll_dice($num_dice, $curr);
			$curr = "";
			$num_dice = 0;
		# Process at end of line
		} elsif ($ch eq "\n") {
			if ($doing eq "minus") {
				$total = ($sofar - $curr);
				if ($total <=0) { $total = 1; }
				print "[" . $total;
			} elsif ($doing eq "plus") {
				print "[" . ($sofar + $curr);
			} else {
				print "[" . roll_dice($num_dice, $curr);
			}
			print "]\n";
		}
		
		if ($ch =~ /[0-9]/) {
			$curr = $curr . $ch;	
		}
	}
		
	# second verse same as the first
	
}

sub roll_dice {

	my $num = $_[0];
	my $sides = $_[1];
	my $x = 0;
	my $total = 0;
	
	for (my $i = 0; $i < $num; $i++) {
		$x = random_number($sides);
		print $x;
		if ($i < ($num - 1)) {
			print ", "	
		} else {
			print "\n";	
		}
		$total = $total + $x;
	}
	
	return $total
	
}











sub random_number {

	# Return a random integer from 1 to number specified as argument
	return int(rand() * $_[0]) + 1;
	
}

where_now("");
